//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
//---------------------------------------------------------------------------
VerInfo myVerInfo;
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
VerInfo::VerInfo()
{
  m_ClearData();
}
//---------------------------------------------------------------------------
void VerInfo::m_ClearData(void)
{
    ZeroMemory((void *)(&m_stFileInfo), sizeof(m_stFileInfo));
    m_wLangID = 0;
    m_wCharsetID = 0;
    m_strProductName = "";
    m_strProductVersion = "";
    m_strOriginalFilename = "";
    m_strFileDescription = "";
    m_strFileVersion = "";
    m_strCompanyName = "";
    m_strLegalCopyright = "";
    m_strLegalTrademarks = "";
    m_strInternalName = "";
    m_strComments = "";
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetFileName()
{
  return m_strFileName;
}
//---------------------------------------------------------------------------
void VerInfo::m_SetFileName(AnsiString strNewName)
{
  m_strFileName = strNewName;
  m_GetVerInfo();
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetFixedFileVersion(void)
{
  AnsiString s0((int)HIWORD(m_stFileInfo.dwFileVersionMS));
  AnsiString s1((int)LOWORD(m_stFileInfo.dwFileVersionMS));
  AnsiString s2((int)HIWORD(m_stFileInfo.dwFileVersionLS));
  AnsiString s3((int)LOWORD(m_stFileInfo.dwFileVersionLS));
  return (s0 + "." + s1 + "." + s2 + "." + s3);
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetFixedProductVersion(void)
{
  AnsiString s0((int)HIWORD(m_stFileInfo.dwProductVersionMS));
  AnsiString s1((int)LOWORD(m_stFileInfo.dwProductVersionMS));
  AnsiString s2((int)HIWORD(m_stFileInfo.dwProductVersionLS));
  AnsiString s3((int)LOWORD(m_stFileInfo.dwProductVersionLS));
  return (s0 + "." + s1 + "." + s2 + "." + s3);
}
//---------------------------------------------------------------------------
WORD VerInfo::m_wGetLangID(void)
{
  return m_wLangID;
}
//---------------------------------------------------------------------------
WORD VerInfo::m_wGetCharsetID(void)
{
  return m_wCharsetID;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetProductName(void)
{
  return m_strProductName;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetProductVersion(void)
{
  return m_strProductVersion;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetOriginalFilename(void)
{
  return m_strOriginalFilename;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetFileDescription(void)
{
  return m_strFileDescription;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetFileVersion(void)
{
  return m_strFileVersion;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetLegalCopyright(void)
{
  return m_strLegalCopyright;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetCompanyName(void)
{
  return m_strCompanyName;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetLegalTrademarks(void)
{
  return m_strLegalTrademarks;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetInternalName(void)
{
  return m_strInternalName;
}
//---------------------------------------------------------------------------
AnsiString VerInfo::m_strGetComments(void)
{
  return m_strComments;
}
//---------------------------------------------------------------------------
void VerInfo::m_GetVerInfo(void)
{
  #define VERSION_INFO_KEY_ROOT TEXT("\\StringFileInfo\\")
  #define VERSION_INFO_KEY_TRANS TEXT("\\VarFileInfo\\Translation")

  const int NUM_VERSION_INFO_KEYS = 10;
  const static TCHAR *VersionKeys[] =
  {
    TEXT("ProductName"),
    TEXT("ProductVersion"),
    TEXT("OriginalFilename"),
    TEXT("FileDescription"),
    TEXT("FileVersion"),
    TEXT("CompanyName"),
    TEXT("LegalCopyright"),
    TEXT("LegalTrademarks"),
    TEXT("InternalName"),
    TEXT("Comments")
  };

  typedef struct _VersionKeyInfo
  {
    TCHAR const *szKey;
    TCHAR *szValue;
  }VKINFO, *LPVKINFO;
  VKINFO gVKArray[NUM_VERSION_INFO_KEYS];

  m_ClearData();

  DWORD dwHandle = 0;
  DWORD	dwLength;
  dwLength = GetFileVersionInfoSize(m_strFileName.c_str(), &dwHandle);
  if(1 > dwLength)
  {
    m_dwLastError = GetLastError();
    return;
  }

  HANDLE hMem;
  LPVOID lpvMem;
  hMem = GlobalAlloc(GMEM_MOVEABLE, dwLength);
  if(NULL == hMem)
  {
    m_dwLastError = GetLastError();
    return;
  }
  lpvMem = GlobalLock(hMem);
  if(NULL == lpvMem)
  {
    m_dwLastError = GetLastError();
    GlobalUnlock(hMem);
    GlobalFree(hMem);
    return;
  }

  BOOL fRet;
  fRet = GetFileVersionInfo(m_strFileName.c_str(),dwHandle,dwLength,(LPVOID)lpvMem);
  if(FALSE == fRet)
  {
    m_dwLastError = GetLastError();
    GlobalUnlock(hMem);
    GlobalFree(hMem);
    return;
  }

  LPVOID lpInfo;
  UINT cch;
  if(VerQueryValue(lpvMem, "\\", &lpInfo, &cch))
  {
    CopyMemory((void*)&m_stFileInfo,(const void*)lpInfo,sizeof(m_stFileInfo)      		   );
  }
    else
    {
      m_dwLastError = GetLastError();
      GlobalUnlock(hMem);
      GlobalFree(hMem);
      return;
    }

  AnsiString strLangID;
  AnsiString strCharset;
  if(VerQueryValue(lpvMem, VERSION_INFO_KEY_TRANS, &lpInfo, &cch))
  {
    m_wLangID = ((WORD *)lpInfo)[0];
    m_wCharsetID = ((WORD *)lpInfo)[1];
    strLangID = strLangID.IntToHex((int)m_wLangID, 4);
    strCharset = strCharset.IntToHex((int)m_wCharsetID, 4);
  }
    else
    {
      m_dwLastError = GetLastError();
      GlobalUnlock(hMem);
      GlobalFree(hMem);
      return;
    }
  AnsiString strVerInfoLangID(strLangID + strCharset);

  TCHAR key[80];
  static TCHAR szNull[1] = TEXT("");
  for (UINT i = 0; i < NUM_VERSION_INFO_KEYS; i++)
  {
    lstrcpy(key, VERSION_INFO_KEY_ROOT);
    lstrcat(key, strVerInfoLangID.c_str());
    lstrcat(key, "\\");
    lstrcat(key, VersionKeys[i]);
    gVKArray[i].szKey = VersionKeys[i];

    if(VerQueryValue(lpvMem, key, &lpInfo, &cch))
    {
      gVKArray[i].szValue = (char *)lpInfo;
    }
      else
      {
	gVKArray[i].szValue = szNull;
      }
  }
  m_strProductName = gVKArray[0].szValue;
  m_strProductVersion = gVKArray[1].szValue;
  m_strOriginalFilename = gVKArray[2].szValue;
  m_strFileDescription  = gVKArray[3].szValue;
  m_strFileVersion = gVKArray[4].szValue;
  m_strCompanyName = gVKArray[5].szValue;
  m_strLegalCopyright = gVKArray[6].szValue;
  m_strLegalTrademarks = gVKArray[7].szValue;
  m_strInternalName = gVKArray[8].szValue;
  m_strComments = gVKArray[9].szValue;

  GlobalUnlock(hMem);
  GlobalFree(hMem);

  m_dwLastError = GetLastError();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonOpen1Click(TObject *Sender)
{
  if(OpenDialog->Execute())
  {
    myVerInfo.FileName = OpenDialog->FileName;
    OldFileName = ExtractFileName(OpenDialog->FileName);
    OldPath = OpenDialog->FileName;
    m_DispData1();
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonOpen2Click(TObject *Sender)
{
  if(OpenDialog->Execute())
  {
    myVerInfo.FileName = OpenDialog->FileName;
    NewFileName = ExtractFileName(OpenDialog->FileName);
    NewPath = OpenDialog->FileName;
    m_DispData2();
  }
}
//---------------------------------------------------------------------------
void TFormMain::m_DispData1(void)
{
  MemoNO1->Text = "# ϥ C++ Builder oɮתT\r\n\r\n";
  MemoNO1->Text = MemoNO1->Text + "ɮ׸|PW١G\t" + myVerInfo.FileName + "\r\n\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "qW١G\t" + myVerInfo.CompanyName + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "ɮ׻G\t" + myVerInfo.FileDescription + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "ɮתG\t" + myVerInfo.FixedFileVersion + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "W١G\t" + myVerInfo.InternalName + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "  @  vG\t" + myVerInfo.LegalCopyright + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "XkӼСG\t" + myVerInfo.LegalTrademarks + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "lɦWG\t" + myVerInfo.OriginalFilename + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "~W١G\t" + myVerInfo.ProductName + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "~G\t" + myVerInfo.ProductVersion + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "y@@tG\t" + myVerInfo.CharsetID + "\r\n";
  MemoNO1->Text = MemoNO1->Text	+ "@@G\t" + myVerInfo.Comments + "\r\n";
  OldVersion = myVerInfo.FixedFileVersion;
}
//---------------------------------------------------------------------------
void TFormMain::m_DispData2(void)
{
  MemoNO2->Text = "# ϥ C++ Builder oɮתT\r\n\r\n";
  MemoNO2->Text = MemoNO2->Text + "ɮ׸|PW١G\t" + myVerInfo.FileName + "\r\n\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "qW١G\t" + myVerInfo.CompanyName + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "ɮ׻G\t" + myVerInfo.FileDescription + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "ɮתG\t" + myVerInfo.FixedFileVersion + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "W١G\t" + myVerInfo.InternalName + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "  @  vG\t" + myVerInfo.LegalCopyright + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "XkӼСG\t" + myVerInfo.LegalTrademarks + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "lɦWG\t" + myVerInfo.OriginalFilename + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "~W١G\t" + myVerInfo.ProductName + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "~G\t" + myVerInfo.ProductVersion + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "y@@tG\t" + myVerInfo.CharsetID + "\r\n";
  MemoNO2->Text = MemoNO2->Text	+ "@@G\t" + myVerInfo.Comments + "\r\n";
  NewVersion = myVerInfo.FixedFileVersion;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonCheckClick(TObject *Sender)
{
  if ( OldFileName == NewFileName )
  {
    if ( OldVersion == NewVersion ) ShowMessage ("ɮתۦPANisʧ@");
      else
        if ( OldVersion < NewVersion ) ShowMessage ("ӷɮפتɮ׸¡ANisʧ@");
          else
          {
            ShowMessage ("ӷɮפتɮ׸sANisʧ@");
            CopyFile (OldPath.c_str(),NewPath.c_str(),false);
          }
  }
    else ShowMessage ("]ɮɮצW٨äۦPANi檩u@");
}
//---------------------------------------------------------------------------

